![](banner.png)

[![](https://img.shields.io/badge/SmartPack--Kernel%20Manager-v15.5-green)](https://github.com/SmartPack/SmartPack-Kernel-Manager/releases/download/v15.5/com.smartpack.kernelmanager-v15.5-release.apk)
![](https://img.shields.io/github/downloads/SmartPack/SmartPack-Kernel-Manager/total)
![](https://img.shields.io/github/downloads/SmartPack/SmartPack-Kernel-Manager/v15.5/total)
![](https://img.shields.io/github/contributors/smartpack/SmartPack-Kernel-Manager)
![](https://img.shields.io/github/license/smartpack/SmartPack-Kernel-Manager)

# Introduction
Welcome to the <strong>beta</strong> development channel of SmartPack-Kernel Manager, a heavily modified version of Kernel Adiutor originally developed by Willi Ye aka Grarak. All the credits go to the original developer. This branch holds the latest changes added to SmartPack-Kernel Manager. The beta builds are exclusively published on the GitHub release page (not on PlayStore). The contributors are requested to send pull requests only to this channel.<br>
<br><strong>Warning</strong>: Be aware that the beta builds contains experimental features. Please expect some bugs.

## Download
[<img src="https://fdroid.gitlab.io/artwork/badge/get-it-on.png"
     alt=""
     height="80">](https://f-droid.org/packages/com.smartpack.kernelmanager)
     [<img src="https://gitlab.com/IzzyOnDroid/repo/-/raw/master/assets/IzzyOnDroid.png"
     alt=""
     height="80">](https://apt.izzysoft.de/fdroid/index/apk/com.smartpack.kernelmanager)
     [<img src="https://i.ibb.co/q0mdc4Z/get-it-on-github.png"
          alt=""
          height="80">](https://github.com/SmartPack/SmartPack-Kernel-Manager/releases/download/v15.5/com.smartpack.kernelmanager-v15.5-release.apk)

## Features
* Almost all the features available in Kernel Adiutor.
* Option to flash recovery zip files while running Android OS.
* A simple and user-friendly Custom Controller, which is totally different to that of the official KA ([Documentation](https://smartpack.github.io/spkm/customcontrols/)).
* A Script Manager to easily create, import, edit, share and execute any properly formatted shell scripts.
* A Kernel downloader, which is also totally different to that of the official KA ([Documentation](https://smartpack.github.io/kerneldownloads/)).
* CPU Input Boost & Devfreq Boost (Sultanxda).
* Simple MSM Thermal (Sultanxda).
* Advanced Control for Fast Charge (yank555.lu) & Boeffla Charge Level Interface (Lord Boeffla).
* K-Lapse Support (tanish2k09)
* Boeffla Sound (Lord Boeffla) with Per-channel Control
* Per-channel control for Flar's sound.
* Significantly different Faux Sound implementation.
* In-built Spectrum Support (frap129).
* Wake and sleep gestures (flar2).
* Adreno Boost (flar2).
* Dynamic Stune Boost (joshuous)
* MSM Sleeper (flar2).
* Boeffla Wakelock Blocker (Lord Boeffla).
* Display Backlight Control (Min & Max).
* Switches to tweak SELinux, Android Doze mode and PrintK logging.
* WireGuard version information.
* Auto-updates (in *About* page).
* Real-time Charging Status.
* RAM & Swap Status.
* LED Blink/Fade support.
* Dedicated Frequently Asked Questions (FAQ) section.
* Also compatible with any devices and kernels.
* And much more…

## Donations
If you like to appreciate my work, please consider donating to me (either via [PayPal](https://www.paypal.me/menacherry/), or [Ko-fi](https://ko-fi.com/sunilpaulmathew/), or by purchasing the [SmartPack Donation Package](https://play.google.com/store/apps/details?id=com.smartpack.donate) from playstore) as it is helpful to continue my projects more active, although it is not at all necessary.<br>
<br><strong>Please note</strong>: Purchasing the donation package will unlock some hidden features in this app.

[<img src="https://raw.githubusercontent.com/SmartPack/SmartPack.github.io/master/asset/pic005.png"
     alt=""
     height="80">](https://www.paypal.me/menacherry/)
[<img src="https://play.google.com/intl/en_us/badges/images/generic/en-play-badge.png"
     alt=""
     height="80">](https://play.google.com/store/apps/details?id=com.smartpack.donate)
[<img src="https://raw.githubusercontent.com/SmartPack/SmartPack.github.io/master/asset/pic010.png"
     alt=""
     height="80">](https://ko-fi.com/sunilpaulmathew/)

## Credits

#### Willi Ye

* [Kernel Adiutor](https://github.com/Grarak/KernelAdiutor)

#### John Wu

* [libsu](https://github.com/topjohnwu/libsu)

#### Chris Renshaw

* [Auto-flash](https://github.com/osm0sis)

#### Joe Maples

* [Spectrum](https://github.com/frap129/spectrum)

#### Translations
* [jason5545](https://github.com/jason5545), Chinese (Traditional)
* [Roiyaru](https://github.com/Roiyaru), Chinese (simplified)
* [YFdyh000](https://github.com/yfdyh000), Chinese (simplified)
* [Andrey](https://github.com/andrey167), Russian
* [Lennoard Silva](https://github.com/Lennoard), Portuguese (Brazilian)
* [SmgKhOaRn](https://github.com/SmgKhOaRn), Korean
* [kiratt](http://4pda.ru/forum/index.php?showuser=5859577), Russian/Ukrainian
* [Mikesew1320](https://github.com/Mikesew1320), Amharic
* [free-bots](https://github.com/free-bots), German
* Alejandro YT, Spanish
* [Fruity-0](https://github.com/Fruity-0), Polish

## Report a bug or request a feature

You can report a bug or request a feature by [opening an issue](https://github.com/SmartPack/SmartPack-Kernel-Manager/issues/new).

#### How to report a bug
* A detailed description of the bug
* Logcat
* Make sure that no similar bugs are already reported

#### How to request a feature
* A detailed description of the feature
* All kind of information
* Paths to sysFS interface
* What's the content of the sysFS interface
* How to apply a new value
* Make sure that no similar feature us already requested.

## License

    Copyright (C) 2020-2021 sunilpaulmathew <sunil.kde@gmail.com>

    SmartPack Kernel Manager is a free softwares: you can redistribute
    it and/or modify it under the terms of the GNU General Public License as
    published by the Free Software Foundation, either version 3 of the License,
    or (at your option) any later version.

    SmartPack Kernel Manager is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
    details.

    You should have received a copy of the GNU General Public License along with
    SmartPack Kernel Manager. If not, see <http://www.gnu.org/licenses/>.

***** ***** ***** ***** ***** ***** ***** ***** ***** ***** *****

## About Kernel Adiutor

[![Build Status](https://travis-ci.org/Grarak/KernelAdiutor.svg?branch=master)](https://travis-ci.org/Grarak/KernelAdiutor)
[![Crowdin](https://d322cqt584bo4o.cloudfront.net/kernel-adiutor/localized.png)](https://crowdin.com/project/kernel-adiutor)

* [Join Google+ Community](https://plus.google.com/communities/108445529270785762340) (Beta Testing)

[![Google Play](http://developer.android.com/images/brand/en_generic_rgb_wo_60.png)](https://play.google.com/store/apps/details?id=com.grarak.kerneladiutor)
[![PayPal](https://www.paypalobjects.com/webstatic/mktg/Logo/pp-logo-200px.png)](https://www.paypal.com/cgi-bin/webscr?cmd=_s-xclick&hosted_button_id=G3643L52LJQ7G)

## Credits

I used following libraries:

* Google: [AndroidX Library](https://developer.android.com/jetpack/androidx/)
* Google: [NavigationView library](https://developer.android.com/reference/com/google/android/material/navigation/NavigationView)
* Ozodrukh: [CircularReveal](https://github.com/ozodrukh/CircularReveal)
* Roman Nurik: [dashclock](https://github.com/romannurik/dashclock)
* Google: [Firebase](https://firebase.google.com)
* Matthew Precious: [swirl](https://github.com/mattprecious/swirl)
* Lopez Mikhael: [CircularImageView](https://github.com/lopspower/CircularImageView)
* Square: [picasso](https://github.com/square/picasso)
* CyanogenMod: [CyanogenMod Platform SDK](https://github.com/CyanogenMod/cm_platform_sdk)
* Akexorcist: [Android-RoundCornerProgressBar](https://github.com/akexorcist/Android-RoundCornerProgressBar)

Also codes from different people:

#### Andrei F.

* [RootUtils](https://github.com/Grarak/KernelAdiutor/blob/master/app/src/main/java/com/grarak/kerneladiutor/utils/root/RootUtils.java)

#### apbaxel

_(Many sys interface paths has been taken from his [UKM-Project](https://github.com/apbaxel/UKM))_

#### Brandon Valosek

* [CpuSpyApp](https://github.com/Grarak/KernelAdiutor/blob/master/app/src/main/java/com/bvalosek/cpuspy/CpuSpyApp.java)
* [CpuStateMonitor](https://github.com/Grarak/KernelAdiutor/blob/master/app/src/main/java/com/bvalosek/cpuspy/CpuStateMonitor.java)
* [OverallFragment](https://github.com/Grarak/KernelAdiutor/blob/master/app/src/main/java/com/grarak/kerneladiutor/fragments/statistics/OverallFragment.java)

## License

    Copyright (C) 2015-2016 Willi Ye <williye97@gmail.com>
    
    Kernel Adiutor is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.
    
    Kernel Adiutor is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
    
    You should have received a copy of the GNU General Public License
    along with Kernel Adiutor.  If not, see <http://www.gnu.org/licenses/>.
